package business;

import network.ConfigurationServer;

import java.util.Hashtable;
import java.util.Vector;
import java.util.Enumeration;

import rmi.EventInfo;
import access.Database;



public class ConfigurationManager
{
    private static ProgramListenerMapTable objPLMT;
    private static RegisteredPrograms objRP;
    private static RegisteredListeners objRL;

    private ConfigurationServer objCS;

    public ConfigurationManager()
    {
        Database objDB = new Database();
        objDB.createFolders();
        objPLMT = new ProgramListenerMapTable();
        objRP = new RegisteredPrograms();
        objRL = new RegisteredListeners();

        try
        {
            objCS = new ConfigurationServer();
            System.out.println("About to Call Initialise() ---CS---"+objCS);
            if(objCS.initialise()==false)
            {

            }

        }
        catch(Exception re)
        {
            re.printStackTrace();
            System.out.println("Remote Exception while creating Conf Server() !!");
        }


    }

    public boolean setNetworkInfo(String sIPAddress, String sPortNo)
    {
        return objCS.setNetworkInfo(sIPAddress,sPortNo);
    }

    public String[] getNetworkInfo()
    {
        return objCS.getNetworkInfo();
    }

    public static boolean registerAuralisedProgram(String sProgramName, Hashtable htEventSoundHandlers)
    {
        objPLMT.registerProgram(sProgramName);

        return objRP.addProgram(sProgramName, htEventSoundHandlers);
    }

    public static boolean unRegisterAuralisedProgram(String sProgramName)
    {
        objPLMT.unRegisterProgramForListener(sProgramName, null);
        return objRP.removeProgram(sProgramName);
    }

    public static boolean registerListener(String sIPAddress, String sPortNo)
    {
        System.out.println("REGISTRATION "+objRL);
        if(objRL.isRegisteredListener(sIPAddress.concat(sPortNo))==false)
        {
            System.out.println("OUT FAILED");
            ListenerInfo objListenerInfo = new ListenerInfo();

            objListenerInfo.setIPAddress(sIPAddress);
            objListenerInfo.setPort(sPortNo );

            objRL.addListener(sIPAddress.concat(sPortNo),objListenerInfo);
         }

       return true;
    }


 public static boolean unRegisterListener(String sIPAddress, String sPortNo)
 {
    objRL.removeListener(sIPAddress.concat(sPortNo));
     return true;
 }

 public static Vector login(String sIPAddress, String sPortNo)
 {
     objRL.getListenerInfo(sIPAddress.concat(sPortNo)).setAvailable(true);
     return objPLMT.getProgramNames();
 }
 public static boolean logout(String sIPAddress, String sPortNo)
 {
     objRL.setListenerLogout(sIPAddress.concat(sPortNo));
     return true;
 }

    public static Hashtable registerProgramForListener(String sProgramName,  String sIPAddress, String sPort)
    {
         if(objPLMT.registerProgramForListener(sProgramName,objRL.getListenerInfo(sIPAddress.concat(sPort)))== true)
        {
          return objRP.getEventSoundHandlers(sProgramName);
        }
        return null;
    }

    public static  boolean unRegisterProgramForListener(String sProgramName, String sIPAddress, String sPort)
    {
        return objPLMT.unRegisterProgramForListener(sProgramName,objRL.getListenerInfo(sIPAddress.concat(sPort)));
    }

    public static Vector[] getListeners(String sProgramName)
    {
        Vector[] vArray= objPLMT.getListeners(sProgramName);
        Vector vAvailable = new Vector();
        String sName= null;
        ListenerInfo objLI= null;

    if(vArray != null)
    {

        for(int iLoop=0; iLoop < vArray[1].size(); iLoop++)
        {
            sName=((String)vArray[0].get(iLoop)).concat((String)vArray[1].get(iLoop));
            objLI=objRL.getListenerInfo(sName);
            vAvailable.add(new Boolean(objLI.isAvailable()));
        }

        Vector vListenerInfo[] = new Vector[3];

        vListenerInfo[0]=vArray[0];
        vListenerInfo[1]=vArray[1];
        vListenerInfo[2]=vAvailable;


        return vListenerInfo;
        }
        else
        {
            System.out.println("FOR GOPI : &$&$*&Configuration Manager. getListeners() returns null");
            return null;
        }
    }

 /*   public static Vector[] getRegisteredListeners(String sProgramName)
    {
        System.out.println("CM---------");
        return objPLMT.getRegisteredListeners(sProgramName);
    }*/

    public static Vector getProgramNames()
    {
        Vector vProgramNames = new Vector();
        Hashtable htProgramNames= objRP.getProgramNames();

        if(htProgramNames==null)
        {
            return null;
        }

        Enumeration objEnum = htProgramNames.keys();

        while(objEnum.hasMoreElements())
        {
           vProgramNames.add(objEnum.nextElement());
        }

        return vProgramNames;
    }

     public void TESTRECEIVEEVENT(String sProgramName, EventInfo objEI)
     {
         try{
         objCS.receiveEvent(sProgramName,objEI);

         }catch(Exception e)
         {
             System.out.println("RMI CMMMMMMMMM");
             e.printStackTrace();
         }
     }
}
