package business;

import access.Database;
import access.DatabaseConstants;
import business.EventSoundMapping;

import java.util.Hashtable;
import java.util.Vector;


public class EventSoundMappingGenerator implements DatabaseConstants
{
    private Hashtable htEventSound = null;
    private String sProgramName = null;

    public EventSoundMappingGenerator()
    {
        htEventSound = new Hashtable();
    }

    public EventSoundMappingGenerator(String sProgramName)
    {
        htEventSound = new Hashtable();
        this.sProgramName =  sProgramName;
    }

    public void generateEventSoundMappings(Vector vLSLTokens)
    {
        LSLTokens objLSL = null;
        String sPackageName =null;
        String sClassName =  null;
        String sMethodName = null;
        String sKeyword = null;
        String sIdentifer = null;
        EventSoundMapping objESM = null;

        StringBuffer sbEventName= null;

        for(int iLoop = 0; iLoop < vLSLTokens.size(); iLoop++)
        {
            objLSL = (LSLTokens)vLSLTokens.get(iLoop);
            objESM = new EventSoundMapping();
             sbEventName= new StringBuffer();
            if((sPackageName=objLSL.getPackageName()) != null)
            {
                sbEventName.append(sPackageName);
                sbEventName.append("_");
            }

            if((sClassName=objLSL.getClassName()) != null)
            {
               sbEventName.append(sClassName);
                sbEventName.append("_");
            }

            if((sMethodName=objLSL.getMethodName()) != null)
            {
               sbEventName.append(sMethodName);
                sbEventName.append("_");
            }

            if((sKeyword=objLSL.getKeyword()) != null)
            {
               sbEventName.append(sKeyword);
                sbEventName.append("_");
            }

            if((sIdentifer = objLSL.getIdentifier()) != null)
            {
                sbEventName.append(sIdentifer);
                sbEventName.append("_");
            }

            int iLastIndex = sbEventName.toString().lastIndexOf('_');

            if(iLastIndex !=  -1)
            {
                sbEventName.deleteCharAt(iLastIndex);
            }

            objESM.setEventName(sbEventName.toString());        //sets the Event Name
            objESM.setSoundVariable(objLSL.getInstrument());    // sets the sound variable

            htEventSound.put(objESM.getEventName(),objESM);     // adds to the hash table
       }

        this.storeEventSoundMappings();
    }


    public String getProgramName() {
        return sProgramName;
    }

    public void setProgramName(String sProgramName) {
        this.sProgramName = sProgramName;
    }

    public void storeEventSoundMappings()
    {
        Database objDB = new Database();

        objDB.writeObject(EVENT_SOUND_MAPPINGS+ sProgramName+ EVENT_SOUND_MAPPINGS_FILE_EXTENSION ,htEventSound);
        //objDB.writeObject("c:/jlisten/"+ sProgramName+".test" ,htEventSound);
    }

    public Hashtable getEventSoundMappings(String sProgramName)
    {

        if((this.sProgramName != null) && (this.sProgramName.equalsIgnoreCase(sProgramName) == true))
        {
            return htEventSound;
        }
        else
        {
            this.sProgramName = sProgramName;

            Database objDB = new Database();

            try
            {
                return (Hashtable) objDB.readObject(EVENT_SOUND_MAPPINGS+ sProgramName +EVENT_SOUND_MAPPINGS_FILE_EXTENSION);
                //return (Hashtable) objDB.readObject("c:/jlisten/"+ sProgramName+".test");

            }
            catch(Exception e)
            {
                System.out.println("EXCEPTION NULL ESM GENERATOR");
                return null;
            }
         }

    }
}


