package business;

import query.Parse;
import query.Node;

import java.io.*;


public class FileManager  implements access.DatabaseConstants
{
    //private final String sMainPath="../..";
    private final String sMainPath="../../JLISTEN";
    private final String sLSLPath=sMainPath+"/lsl/";
    private final String sDecoratedPath=sMainPath+"/decorated/";

    private final String sRMIInterface="ExecPlatformInterface.class";

    //private final String sActualFilesPath="../execplatform";
    private final String sActualFilesPath="execplatform";
    //private final String sActualFilesPath="instrumentor/execplatform";
    private final String sStubPath = "execplatform/ConfigurationServer_Stub.class";
    private final String sSkelPath = "execplatform/ConfigurationServer_Skel.class";

    private final String sRMIPath =sActualFilesPath+"/"+sRMIInterface;
    private final String sEventInfoPath=sActualFilesPath+"/EventInfo.class";
    private final String sConnectionFilePath=sActualFilesPath+"/Connection.java";

    private final String sConfigurationFilePath = CONF_SERVER_INFO + "/config.txt";

    private final String sImportConnectionHeader="package ";
    private final String sRMIPackage="rmi";
    private final String sNetworkPackage="network";

    public FileManager()
    {
        File fLSLDir = new File(sLSLPath);

         if(fLSLDir.exists() == false)
               fLSLDir.mkdirs();
    }


    private void writeDecoratedCode(String sJavaFilePath , Parse objParse)
    {
        if(objParse != null)
        {
            try
            {
             System.out.println("============="+sJavaFilePath);
            Node objRoot=objParse.getRoot();
            File fDecoratedFile=new File(sJavaFilePath);

            FileWriter fwDecoratedFile = new FileWriter(fDecoratedFile);
            objRoot.print(objParse.getCommentList(), fwDecoratedFile);
            fwDecoratedFile.close();

            }
            catch (IOException e)
            {
                System.out.println("DECORATED FILE EXCEPTION");
            }
        }
     }

    public boolean storeLSLFile(String[] sLSL, String sJavaFileName)
    {
        FileWriter fwLSL = null;

        try
        {
            fwLSL = new FileWriter(sLSLPath+sJavaFileName);

            for(int iLoop=0 ;iLoop < sLSL.length; iLoop++)
            {
                fwLSL.write(sLSL[iLoop]);
                fwLSL.write('\n');
            }

            fwLSL.close();
        }

        catch(Exception e)
        {
            System.out.println("NULL EXCEPTION LSL STORAGE");
            return false;
        }
        return true;
    }


    public  boolean createInstrumentedPackage(String sJavaFileName , Parse objParse)
    {

       //String sImportConnection=sImportConnectionHeader+sJavaFileName+";\n";
        String sImportConnection="";
       String sDecorated = sDecoratedPath+sJavaFileName+"/";
       String sRMIinDecorated=sDecorated+sRMIPackage+"/" ;
       String sNetworkinDecorated = sDecorated + sNetworkPackage +"/";

        System.out.println("DECORATED PATH="+sDecorated);
        System.out.println("RMI PATH="+sRMIinDecorated);
        int iChar=-1;
        File fRMIPackage= new File(sRMIinDecorated);
        File fDecoratedPackage= new File(sDecorated);
        File fNetworkPackage= new File(sNetworkinDecorated);

        System.out.println("Decorated Package made status : " + fDecoratedPackage.mkdirs());
        System.out.println("RMI PACKAGE MADE STATUS : " +fRMIPackage.mkdirs());
        System.out.println("Network PACKAGE MADE STATUS : " +fNetworkPackage.mkdirs());

        try
        {
/*
            System.out.println("RMI Path : "+sRMIPath);
            File fRMI = new File(sRMIPath);
            System.out.println("Absolute Path : "+ fRMI.getAbsolutePath());
            FileReader frRMI = new FileReader(sRMIPath);
            FileWriter fwRMI = new FileWriter(sRMIinDecorated+sRMIInterface);

            while((iChar=frRMI.read()) != -1)
            {
                fwRMI.write(iChar);
            }

            frRMI.close();
            fwRMI.close();*/

            //File Copy ----------
            //fileCopy(sRMIPath,sRMIinDecorated+sRMIInterface);

            System.out.println("Event Info Path" + sEventInfoPath);


   /*         FileReader frEventInfo = new FileReader(sEventInfoPath);
            FileWriter fwEventInfo = new FileWriter(sRMIinDecorated+"EventInfo.class");

            while((iChar=frEventInfo.read()) != -1)
            {
                fwEventInfo.write(iChar);
            }

            frEventInfo.close();
            fwEventInfo.close();*/


//File Copy ----------
            fileCopy(sEventInfoPath,sRMIinDecorated+"EventInfo.class");

      /*      FileReader frStub = new FileReader(sStubPath);
            FileWriter fwStub = new FileWriter(sNetworkinDecorated+"ConfigurationServer_Stub.class");

            while((iChar=frStub.read()) != -1)
            {
                fwStub.write(iChar);
            }
            frStub.close();
            fwStub.close();*/

//File Copy ----------
            fileCopy(sStubPath,sNetworkinDecorated+"ConfigurationServer_Stub.class");


            /*FileReader frSkel = new FileReader(sSkelPath);
            FileWriter fwSkel = new FileWriter(sNetworkinDecorated+"ConfigurationServer_Skel.class");

            while((iChar=frSkel.read()) != -1)
            {
                fwSkel.write(iChar);
            }

            frSkel.close();
            fwSkel.close();*/

//File Copy ----------
            fileCopy(sSkelPath,sNetworkinDecorated+"ConfigurationServer_Skel.class");

/*
            FileReader frConfig = new FileReader(sConfigurationFilePath);
            FileWriter fwConfig = new FileWriter(sRMIinDecorated+"config.txt");

            while((iChar = frConfig.read()) != -1)
            {
                fwConfig.write(iChar);
            }

            frConfig.close();
            fwConfig.close();
*/

//File Copy ----------
            fileCopy(sConfigurationFilePath,sRMIinDecorated+"config.txt");


            /*FileReader frExecin = new FileReader(sConfigurationFilePath);
            FileWriter fwExecin = new FileWriter(sDecorated+"ExecPlatformInterface.class");

            while((iChar = frExecin.read()) != -1)
            {
                fwExecin.write(iChar);
            }

            frExecin.close();
            fwExecin.close();*/

//File Copy ----------
            fileCopy(sActualFilesPath+"/ExecPlatformInterface.class",sRMIinDecorated+"ExecPlatformInterface.class");

/*
            FileReader frListenerIn = new FileReader(sConfigurationFilePath);
            FileWriter fwListenerIn = new FileWriter(sDecorated+"ListenerInterface.class");

            while((iChar = frListenerIn.read()) != -1)
            {
                fwListenerIn.write(iChar);
            }

            frListenerIn.close();
            fwListenerIn.close();*/

//File Copy ----------
            fileCopy(sActualFilesPath+"/ListenerInterface.class",sRMIinDecorated+"ListenerInterface.class");


            /*FileReader frAuralizerIn = new FileReader(sConfigurationFilePath);
            FileWriter fwAuralizerIn = new FileWriter(sDecorated+"AuralizerInterface.class");

            while((iChar = frAuralizerIn.read()) != -1)
            {
                fwAuralizerIn.write(iChar);
            }

            frAuralizerIn.close();
            fwAuralizerIn.close();*/

//File Copy ----------
            fileCopy(sActualFilesPath+"/AuralizerInterface.class",sRMIinDecorated+"AuralizerInterface.class");


  /*          FileReader frConfServerIn = new FileReader(sConfigurationFilePath);
            FileWriter fwConfServerIn = new FileWriter(sDecorated+"ConfServerInterface.class");

            while((iChar = frConfServerIn.read()) != -1)
            {
                fwConfServerIn.write(iChar);
            }

            frConfServerIn.close();
            fwConfServerIn.close();
*/
//File Copy ----------
            fileCopy(sActualFilesPath+"/ConfServerInterface.class",sRMIinDecorated+"ConfServerInterface.class");


 /*           FileReader frConnection = new FileReader(sConnectionFilePath);
            FileWriter fwConnection = new FileWriter(sRMIinDecorated+"Connection.java");

            fwConnection.write(sImportConnection);

            while((iChar = frConnection.read()) != -1)
            {
                fwConnection.write(iChar);
            }

            frConnection.close();
            fwConnection.close();*/
 //File Copy ----------
            fileCopy(sConnectionFilePath,sRMIinDecorated+"Connection.java");


            writeDecoratedCode(sDecorated+"/"+sJavaFileName+".java" , objParse);

        }
        catch(Exception e)
        {
            e.printStackTrace();
            System.out.println("EXCEPTION FILE MANAGER");
        }

        return true;
    }


    public boolean fileCopy(String sSource, String sDestination)
    {
        try
        {
        FileInputStream fis = new FileInputStream(sSource);
        FileOutputStream fos = new FileOutputStream(sDestination);

        System.out.println("\n\nInput File Path : " + new File(sSource).getAbsolutePath());
        System.out.println("\n\nOutput File Path : " + new File(sDestination).getAbsolutePath());

        int iSize = fis.available();
        byte bArray[]=null;

        if(iSize != 0)
        {
            bArray = new byte[iSize];

            System.out.println("Bytes Read : " + fis.read(bArray));
            fos.write(bArray);

            fis.close();
            fos.close();

            return true;
        }
        else
        {
            return false;
        }
        }
        catch(IOException ioe)
        {
            ioe.printStackTrace();
            return false;
        }
    }

}




