package business;

import java.util.Vector;

public class LSLCreator implements LSLSpecifiers
{
   private InstrumentLoader objInstrumentLoader = null;

   public LSLCreator()
   {
        objInstrumentLoader =  new InstrumentLoader();
   }

   public Vector getInstrumentNames()
   {
       return objInstrumentLoader.loadInstrumentNames();
   }

   public String[] getEvents()
   {
        return sEvents;
   }

   public String[] getScopes()
   {
       return sScopes;
   }

    public String[] getLSLBodyTemplate(String sJavaFileName)
    {
       String[] sLSL= {"begin auralspec","specmodule "+sJavaFileName,"begin "+sJavaFileName,"end "+sJavaFileName,"end auralspec"};

        return sLSL;
    }


   public String createLSLStatement(LSLTokens objTokens)
   {
       StringBuffer sbLSL = new StringBuffer();
       String sKeyword=objTokens.getKeyword();
       String sIdentifier=objTokens.getIdentifier();
       String sMethod=objTokens.getMethodName();
       String sClass=objTokens.getClassName();
       String sPackage=objTokens.getPackageName();

       sbLSL.append("notify");

       if((sPackage == null) && (sMethod==null) && (sClass==null))
       {
         sbLSL.append(" all");
       }

       if(sKeyword != null)
       {
          if(sKeyword.equalsIgnoreCase("dtrack") == true)
          {
             sbLSL.append(" dtrack "+sIdentifier);
          }
          else if(sKeyword.equalsIgnoreCase("method_call_begin") == true)
          {
             sbLSL.append(" method=method_call_entry: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
          }
          else if(sKeyword.equalsIgnoreCase("method_call_end") == true)
          {
             sbLSL.append(" method=method_call_exit: \""+sIdentifier+"\"");
              if(objTokens.getNoofParameters() > 0)
               {
                   sbLSL.append(" param");
                   Vector vParameters = objTokens.getParameters();

                   for(int iLoop=0; iLoop < objTokens.getNoofParameters(); iLoop++ )
                   {
                       if(iLoop > 0)
                       {
                         sbLSL.append(" and "+vParameters.get(iLoop));
                       }
                       else
                       {
                           sbLSL.append(" "+vParameters.get(iLoop));
                       }
                   }
               }
           }
          else if(sKeyword.equalsIgnoreCase("finalize") == true)
          {
             sbLSL.append(" finalize=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("finally") == true)
          {
             sbLSL.append(" finally=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("constructor") == true)
          {
             sbLSL.append(" classinstantiation=\""+sIdentifier+"\"");
          }
          else if(sKeyword.equalsIgnoreCase("super") == true)
          {
             sbLSL.append(" super=\""+sIdentifier+"\"");
          }
          else if((sKeyword.equalsIgnoreCase("atrack_method") == true) || (sKeyword.equalsIgnoreCase("atrack_class") == true))
          {
             sbLSL.append(" atrack when "+sIdentifier+"_begin until "+sIdentifier+"_end");
          }
         else
          {
            sbLSL.append(" rule="+sKeyword);
          }
        }

        if(sMethod != null)
        {
            sbLSL.append(" in method="+sMethod);
        }
        if(sClass != null)
        {
            sbLSL.append(" in class="+sClass);
        }
        if(sPackage != null)
        {
            sbLSL.append(" in package="+sPackage);
        }

       sbLSL.append(" using "+objTokens.getInstrument()+" ;");

       return sbLSL.toString();
   }

}

