package business;

import java.io.Serializable;
import java.util.Vector;

public class LSLTokens implements Serializable
{
    private String sClassName = null;
    private String sMethodName = null;
    private String sPackageName = null;
    private Vector vMethodScopeParameters;
    private String sKeyword = null;
    private String sIdentifier = null;
    private boolean bActivity = false;
    private String sInstrument =null;
    private Vector vParameters= null;

    public LSLTokens(String sPackage, String sClass, String sMethod, Vector vMethodParameters,String sKeyword, String sIdentifier, boolean bActivity, String sInstrument, Vector vParameters)
    {
        this.sClassName=sClass;
        this.sPackageName=sPackage;
        this.sMethodName=sMethod;
        this.vMethodScopeParameters=vMethodParameters;
        this.sKeyword=sKeyword;
        this.sIdentifier=sIdentifier;
        this.sInstrument=sInstrument;
        this.bActivity=bActivity;
        this.vParameters=vParameters;
    }

    public LSLTokens()
    {

    }

    public String getClassName() {
        return sClassName;
    }

    public void setClassName(String sClassName) {
        this.sClassName = sClassName;
    }

    public String getMethodName() {
        return sMethodName;
    }

    public void setMethodName(String sMethodName) {
        this.sMethodName = sMethodName;
    }

    public String getPackageName() {
        return sPackageName;
    }

    public void setPackageName(String sPackageName) {
        this.sPackageName = sPackageName;
    }

    public String getKeyword() {
        return sKeyword;
    }

    public void setKeyword(String sKeyword) {
        this.sKeyword = sKeyword;
    }

    public String getIdentifier() {
        return sIdentifier;
    }

    public void setIdentifier(String sIdentifier) {
        this.sIdentifier = sIdentifier;
    }


    public String getInstrument() {
        return sInstrument;
    }

    public void setInstrument(String sInstrument) {
        this.sInstrument = sInstrument;
    }

    public Vector getParameters() {
        return vParameters;
    }

    public void setParameters(Vector vParameters) {
        this.vParameters = vParameters;
    }

    public int getNoofParameters()
    {
        if(vParameters == null)
        {
            return -1;
        }
        else
        {
            return vParameters.size();
        }
    }

    public int getNoofMethodScopeParameters()
    {
        if(vMethodScopeParameters == null)
        {
            return -1;
        }
        else
        {
            return vMethodScopeParameters.size();
        }
    }

    public boolean isActivity() {
        return bActivity;
    }

    public void setActivity(boolean bActivity) {
        this.bActivity = bActivity;
    }

    public Vector getMethodScopeParameters() {
        return vMethodScopeParameters;
    }

    public void setMethodScopeParameters(Vector vMethodScopeParameters) {
        this.vMethodScopeParameters = vMethodScopeParameters;
    }

}