package business;


import access.Database;
import access.DatabaseConstants;
import java.util.Vector;

import rmi.EventInfo;


public class Recorder implements DatabaseConstants
{

    long lTime=0;
    String sProgramName=null;
    Vector vBuffer[] = new Vector[2]; // Vector[0] contains TIME, Vector[1]  contains EventInfo object
    public Recorder(String sProgramName)
    {
       this.sProgramName = sProgramName;
       vBuffer[0] = new Vector();
       vBuffer[1] = new Vector();
    }

    public void setStartTime()
    {
        lTime = System.currentTimeMillis();
    }

    public void recordEvent(EventInfo objEI)
    {
        System.out.println("RECORDING EVENTS");
        vBuffer[0].add(new Long(System.currentTimeMillis()-lTime));
        vBuffer[1].add(objEI);

/*        if(vBuffer[0].size() > 1){
        System.out.println(vBuffer[0].get(1) + " : TIME");
        System.out.println(vBuffer[1].get(1) + " : EVENT INFO OBJECT");
        }*/
    }

    public boolean storeRecordedProgram()
    {
        Database objDB = new Database();

        System.out.println("EXCEPTION   -------- recorded..................");
        return objDB.writeObject(RECORDED_PROGRAM + sProgramName + RECORDED_PROGRAM_FILE_EXTENSION, vBuffer);
    }

    public Vector[] retrieveRecordedProgram()
    {
        Database objDB = new Database();

        try
        {
            Vector vBuffer[] = (Vector[])objDB.readObject(RECORDED_PROGRAM + sProgramName + RECORDED_PROGRAM_FILE_EXTENSION);
            this.vBuffer = vBuffer;
            return vBuffer;
        }
        catch(Exception e)
        {
            e.printStackTrace();
            return null;
        }
    }
}