package view;

import javax.swing.*;
import javax.swing.table.DefaultTableModel;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Enumeration;


import business.ListenerManager;

public class MainFrame extends JFrame implements ActionListener, FocusListener, WindowListener
{


    final static private JFrame jfSoundDB = new JFrame("SOUND VARIABLE - VALUE MAPPING");

    private JTabbedPane jtpMain = new JTabbedPane();

    private JPanel jpAuthentication = new JPanel();
    private BorderLayout blAuthentication = new BorderLayout();

    private JPanel jpHeader = new JPanel();
    private JLabel jlblHeader = new JLabel();


    private JPanel jpNetworkInfo = new JPanel();

    private JPanel jpRegister = new JPanel();
    private JButton jbLogout = new JButton();
    private JButton jbLogin = new JButton();

    private JPanel jpNetworkInputs = new JPanel();

    private JLabel jlblConfServerIPAddress = new JLabel("Configuration Server IP Address");
    private JLabel jlblConfServerPortNo = new JLabel("Configuration Server Port No");
    private JLabel jlblHostPortNo = new JLabel("Host Port No");
    private JLabel jlblHostIPAddress = new JLabel("Host IP Address");

    private JTextField jtfHostIPAddress = new JTextField();
    private JTextField jtfConfServerIPAddress = new JTextField();
    private JTextField jtfHostPortNo = new JTextField();
    private JTextField jtfConfServerPortNo = new JTextField();


    private JPanel jpStatus = new JPanel();

    private BorderLayout blNetworkInfo = new BorderLayout();

    private JPanel jpPrograms = new JPanel();
    private BorderLayout blPrograms = new BorderLayout();
    private JPanel jpProgramInfoHeader = new JPanel();
    private JLabel jlblProgramInfoHeader = new JLabel();
    private JPanel jpProgramInfoStatus = new JPanel();
    private JLabel jlblProgramStatus = new JLabel();
    private JLabel jlblAuthenticationStatus = new JLabel();
    private JPanel jpProgramsList = new JPanel();
    private JScrollPane jspRegisteredPrograms = new JScrollPane();
    private JList jlRegisteredPrograms = new JList();
    private DefaultListModel dlmRegisteredPrograms = new DefaultListModel();
    private JScrollPane jspNewProgramsList = new JScrollPane();
    private JList jlNewProgramsList = new JList();
    private DefaultListModel dlmNewProgramsList = new DefaultListModel();
    private JButton jbUnregister = new JButton();
    private JButton jbRegister = new JButton();
    private JLabel jlblRegisteredPrograms = new JLabel();
    private JLabel jlblNewPrograms = new JLabel();
    private JPanel jpEventSoundInfoStatus = new JPanel();
    private JLabel jlblEventSoundInfoStatus = new JLabel();
    private JPanel jpEventSoundInfo = new JPanel();
    private BorderLayout blEventSoundInfo = new BorderLayout();
    private JPanel jpEventSoundMapping = new JPanel();
    private JLabel jlblEventInfoHeader = new JLabel();
    private JPanel jpEventInfoHeader = new JPanel();
    private JLabel jlblProgram = new JLabel();
    private JComboBox jcbProgramsList = new JComboBox();
    private JScrollPane jspEventSoundInfo = new JScrollPane();
    private static JTable jtEventSoundInfo; //= new JTable();
    private static DefaultTableModel dtmEventSoundInfo; //= new DefaultTableModel(new String[]{"Event/Activity", "Status", "Default Value", "Current Value", "Edit"}, 0);
    private JButton jbUpdate = new JButton();
    private JLabel jlblRecordedProgram = new JLabel();
    private JScrollPane jspOrdinaryPrograms = new JScrollPane();
    private JScrollPane jspRecordedPrograms = new JScrollPane();
    private JList jlRecordedPrograms = new JList();
    private DefaultListModel dlmRecordedPrograms = new DefaultListModel();
    private DefaultListModel dlmOrdinaryPrograms = new DefaultListModel();
    private JList jlOrdinaryPrograms = new JList();
    private JPanel jpRecorderStatus = new JPanel();
    private JLabel jlblRecorderStatus = new JLabel();
    private JPanel jpRecorder = new JPanel();
    private JButton jbAddRecordedProgram = new JButton();
    private JLabel jlblUnrecordedPrograms = new JLabel();
    private BorderLayout blRecorder = new BorderLayout();
    private JPanel jpRecorderInfo = new JPanel();
    private JLabel jlblRecorderHeader = new JLabel();
    private JPanel jpRecorderHeader = new JPanel();
    private JButton jbRemoveRecordedProgram = new JButton();
    private JButton jbPlay = new JButton();
    private JButton jbStop = new JButton();
    private JButton jbUnregisterListener = new JButton();
    private JButton jbRegisterListener = new JButton();

    ListenerManager objLM = null;

    public MainFrame()
    {
        objLM = new ListenerManager();
        try
        {
            jbInit();
            addListeners();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    public void windowClosing(WindowEvent we)
    {

        if(jbLogout.isEnabled()==true)
        {
            if (objLM.logoutListener(jtfHostIPAddress.getText(), jtfHostPortNo.getText()) == true)
            {
                JOptionPane.showMessageDialog(null, "Logout Successful !", "Logged out", JOptionPane.PLAIN_MESSAGE);
            }
            else
            {
                JOptionPane.showMessageDialog(null, "Logout Unsuccessful !", "Log out Failure", JOptionPane.ERROR_MESSAGE);
                System.out.println("NOT ABLE TO LOGOUT");
            }
        }

        this.setVisible(false);
        System.exit(0);
    }

    public void windowClosed(WindowEvent we)
    {
    }

    public void windowOpened(WindowEvent we)
    {

    }

    public void windowDeactivated(WindowEvent we)
    {

    }

    public void windowActivated(WindowEvent we)
    {

    }

    public void windowDeiconified(WindowEvent we)
    {

    }

    public void windowIconified(WindowEvent we)
    {

    }


    private void addListeners()
    {
        jtfConfServerIPAddress.setActionCommand("ConfServerIPAddress");
        jtfConfServerIPAddress.addFocusListener(this);

        jtfConfServerPortNo.setActionCommand("ConfServerPortNo");
        jtfConfServerPortNo.addFocusListener(this);

        jtfHostPortNo.setActionCommand("HostIPAddress");
        jtfHostPortNo.addFocusListener(this);

        jtfHostIPAddress.setActionCommand("HostPortNo");
        jtfHostIPAddress.addFocusListener(this);

        jbLogin.setActionCommand("Login");
        jbLogin.addActionListener(this);
        jbLogin.addFocusListener(this);

        jbLogout.setActionCommand("Logout");
        jbLogout.addActionListener(this);
        jbLogout.addFocusListener(this);

        jbRegister.setActionCommand("Register");
        jbRegister.addFocusListener(this);
        jbRegister.addActionListener(this);


        jbUnregister.setActionCommand("Unregister");
        jbUnregister.addFocusListener(this);
        jbUnregister.addActionListener(this);

        jbUnregisterListener.setActionCommand("Unregister Listener");
        jbUnregisterListener.addFocusListener(this);
        jbUnregisterListener.addActionListener(this);

        jbRegisterListener.setActionCommand("Register Listener");
        jbRegisterListener.addFocusListener(this);
        jbRegisterListener.addActionListener(this);

        jspNewProgramsList.addFocusListener(this);

        jlRegisteredPrograms.addFocusListener(this);

        //jlUnregisteredPrograms.addFocusListener(this);
        jlNewProgramsList.addFocusListener(this);
        //disableRegistrationFields();

    }

    public void disableRegistrationFields()
    {
        disableLogin();
        disableLogout();
        disableRegisterListener();
        disableUnRegisterListener();
    }

    public void actionPerformed(ActionEvent ae)
    {

    }

    public void focusGained(FocusEvent fe)
    {
        handleFocus4AuthenticationPane(fe);
        handleFocus4ProgramsPane(fe);

        //System.out.println(fe.getSource().toString());
    }

    public static void showSoundDB()
    {

        if(jfSoundDB.isVisible()==true)
        {
            return;
        }



        JPanel jpSoundDB = new JPanel();
        JPanel jpNorth = new JPanel();

        JPanel jpSouth = new JPanel();
        JPanel jpCenter = new JPanel();

        //jfSoundDB.setContentPane();


        jpSoundDB.setLayout(new BorderLayout());

        final JList jlSound = new JList(ListenerManager.getInstrumentNames());

        jlSound.setVisibleRowCount(20);

        JScrollPane jspSound = new JScrollPane();

        jspSound.setViewportView(jlSound);

        JButton jbYES = new JButton("  OK  ");
        JButton jbNO = new JButton("CANCEL");

        jpSouth.add(jbYES);
        jpSouth.add(jbNO);

        jbYES.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                String sValue = (String) jlSound.getSelectedValue();
                if (sValue != null)
                    dtmEventSoundInfo.setValueAt(sValue, jtEventSoundInfo.getSelectedRow(), 3);
                jfSoundDB.setVisible(false);
            }
        });

        jbNO.addActionListener(new ActionListener()
        {
            public void actionPerformed(ActionEvent ae)
            {
                jfSoundDB.setVisible(false);
            }
        });

        jpNorth.add(new JLabel("SOUND  "));
        jpCenter.add(jspSound);


        jpSoundDB.add(jpNorth, BorderLayout.NORTH);
        jpSoundDB.add(jpSouth, BorderLayout.SOUTH);
        jpSoundDB.add(jpCenter, BorderLayout.CENTER);

        jfSoundDB.getContentPane().add(jpSoundDB);
        jfSoundDB.setBounds(200, 100, 200, 500);
        jfSoundDB.setVisible(true);

        jfSoundDB.addWindowListener(new WindowAdapter()
        {
            public void WindowClosing(WindowEvent we)
            {
                jfSoundDB.setVisible(false);
            }
        });

        jfSoundDB.setResizable(false);
    }


    private void handleFocus4ProgramsPane(FocusEvent fe)
    {
        if (fe.getSource() == jbRegister)
        {
            jlblProgramStatus.setText("Select a New Program, Press '<' to Register");
        }
        else if (fe.getSource() == jbUnregister)
        {
            jlblProgramStatus.setText("Select a Registered Program, Press '>' to Unregister");
        }
        else if (fe.getSource() == jlRegisteredPrograms)
        {
            jlblProgramStatus.setText("List of Registered Programs");
        }
        else if (fe.getSource() == jspNewProgramsList)
        {
            jlblProgramStatus.setText("List of New Programs");
        }
        else if (fe.getSource() == jlNewProgramsList)
        {
            jlblProgramStatus.setText("List of New Programs");
        }
    }

    private void disableLogout()
    {
        //System.out.println("disableLogout");
        jbLogout.setEnabled(false);
    }

    private void enableLogout()
    {
        //System.out.println("enableLogout");
        jbLogout.setEnabled(true);
    }

    private void disableLogin()
    {
        //System.out.println("disableLogin");
        jbLogin.setEnabled(false);
    }

    private void enableLogin()
    {
        //System.out.println("enableLogin");
        jbLogin.setEnabled(true);

    }

    private void enableRegisterListener()
    {
        jbRegisterListener.setEnabled(true);
    }

    private void disableRegisterListener()
    {
        jbRegisterListener.setEnabled(false);
    }

    private void disableUnRegisterListener()
    {

        jbUnregisterListener.setEnabled(false);
    }


    private void enableUnregisterListener()
    {
        jbUnregisterListener.setEnabled(true);
    }


    private void handleFocus4AuthenticationPane(FocusEvent fe)
    {
        if (fe.getSource() == jbLogin)
        {
            jlblAuthenticationStatus.setText("Press 'Alt-i' to Login");
        }
        else if (fe.getSource() == jbLogout)
        {
            jlblAuthenticationStatus.setText("Press 'Alt-o' to Logout");
        }
        else if (fe.getSource() == jtfConfServerIPAddress)
        {
            jlblAuthenticationStatus.setText("Enter Configuration Server IP Address.");
        }
        else if (fe.getSource() == jtfConfServerPortNo)
        {
            jlblAuthenticationStatus.setText("Enter Configuration Server Port No.");
        }
        else if (fe.getSource() == jtfHostPortNo)
        {
            jlblAuthenticationStatus.setText("Enter Host Port No.");
        }
        else if (fe.getSource() == jtfHostIPAddress)
        {
            jlblAuthenticationStatus.setText("Enter Host IP Address.");
        }
        else if (fe.getSource() == jbRegisterListener)
        {
            jlblAuthenticationStatus.setText("Press 'Alt-R' to Register Listener");
        }
        else if (fe.getSource() == jbUnregisterListener)
        {
            jlblAuthenticationStatus.setText("Press 'Alt-U' to Unregister Listener");
        }
    }

    public void focusLost(FocusEvent fe)
    {
        jlblAuthenticationStatus.setText("");
    }

    private void jbInit() throws Exception
    {

        try
        {
            this.setState(Frame.NORMAL);
            this.setTitle("Listener");


            dtmEventSoundInfo = new DefaultTableModel() {
                   // This method returns the Class object of the first
                   // cell in specified column in the table model.
                   // Unless this method is overridden, all values are
                   // assumed to be the type Object.
                   public Class getColumnClass(int columnIndex) {
                       Object o = getValueAt(0, columnIndex);
                       if (o == null) {
                           return Object.class;
                       } else {
                           return o.getClass();
                       }
                   }
               };

           jtEventSoundInfo = new JTable(dtmEventSoundInfo);


           dtmEventSoundInfo.addColumn("Event/ Activity", new Object[]{new String()});
           dtmEventSoundInfo.addColumn("Status", new Object[]{Boolean.FALSE});
           dtmEventSoundInfo.addColumn("Default Value", new Object[]{new String()});
           dtmEventSoundInfo.addColumn("Current Value", new Object[]{new String()});
           dtmEventSoundInfo.addColumn("Update", new Object[]{new JButton()});


            jlRegisteredPrograms = new JList(dlmRegisteredPrograms);
            jlNewProgramsList = new JList(dlmNewProgramsList);

            jlRecordedPrograms = new JList(dlmRecordedPrograms);
            jlOrdinaryPrograms = new JList(dlmOrdinaryPrograms);

            jlRegisteredPrograms.setSelectionMode(DefaultListSelectionModel.SINGLE_SELECTION);
            jlNewProgramsList.setSelectionMode(DefaultListSelectionModel.SINGLE_SELECTION);

            jlRecordedPrograms.setSelectionMode(DefaultListSelectionModel.SINGLE_SELECTION);
            jlOrdinaryPrograms.setSelectionMode(DefaultListSelectionModel.SINGLE_SELECTION);

            jpAuthentication.setToolTipText("Authentication");
            jpAuthentication.setLayout(blAuthentication);
            jpHeader.setBorder(BorderFactory.createEtchedBorder());
            jpHeader.setMinimumSize(new Dimension(400, 40));
            jpHeader.setPreferredSize(new Dimension(400, 40));
            jlblHostPortNo.setBounds(new Rectangle(41, 85, 98, 29));
            jbLogout.setText("Logout");
            jbLogout.addActionListener(new MainFrame_jbLogout_actionAdapter(this));
            jbLogout.setBounds(new Rectangle(476, 34, 79, 30));
            jbLogout.setToolTipText("Logout");
            jbLogout.setActionCommand("LOGOUT");
            jbLogout.setMnemonic('O');

            jtfHostIPAddress.setBorder(BorderFactory.createLineBorder(Color.black));
            jtfHostIPAddress.setOpaque(true);
            jtfHostIPAddress.setToolTipText("Host IP Address");
            jtfHostIPAddress.setBounds(new Rectangle(371, 34, 118, 31));

            jpNetworkInputs.setLayout(null);
            jpNetworkInputs.setBorder(BorderFactory.createEtchedBorder());
            jpNetworkInfo.setLayout(blNetworkInfo);

            jlblConfServerIPAddress.setBounds(new Rectangle(41, 136, 182, 31));
            jtfHostPortNo.setBorder(BorderFactory.createLineBorder(Color.black));
            jtfHostPortNo.setDebugGraphicsOptions(0);
            jtfHostPortNo.setToolTipText("Host Port No");
            jtfHostPortNo.setBounds(new Rectangle(371, 85, 118, 31));

            jtfConfServerIPAddress.setBorder(BorderFactory.createLineBorder(Color.black));
            jtfConfServerIPAddress.setToolTipText("Configuration Server IP Address");
            jtfConfServerIPAddress.setBounds(new Rectangle(371, 136, 118, 31));

            jpStatus.setBorder(BorderFactory.createEtchedBorder());
            jpStatus.setMinimumSize(new Dimension(400, 30));
            jpStatus.setPreferredSize(new Dimension(400, 30));
            jlblConfServerPortNo.setBounds(new Rectangle(41, 186, 182, 28));

            jbLogin.setBounds(new Rectangle(375, 34, 81, 30));
            jbLogin.setToolTipText("Login");
            jbLogin.setActionCommand("LOGIN");
            jbLogin.setMnemonic('I');
            jbLogin.setText("Login");
            jbLogin.addActionListener(new MainFrame_jbLogin_actionAdapter(this));

            jtfConfServerPortNo.setBorder(BorderFactory.createLineBorder(Color.black));
            jtfConfServerPortNo.setToolTipText("Configuration Server Port No");
            jtfConfServerPortNo.setBounds(new Rectangle(371, 186, 118, 31));

            jlblHeader.setFont(new java.awt.Font("SansSerif", 1, 16));
            jlblHeader.setBorder(null);
            jlblHeader.setDebugGraphicsOptions(0);
            jlblHeader.setToolTipText("");
            jlblHeader.setText("Listener Network Information");
            jlblHostIPAddress.setBounds(new Rectangle(41, 34, 118, 45));

            jpRegister.setBorder(BorderFactory.createEtchedBorder());
            jpRegister.setMinimumSize(new Dimension(400, 100));
            jpRegister.setPreferredSize(new Dimension(400, 100));
            jpRegister.setLayout(null);

            jpPrograms.setLayout(blPrograms);
            jpProgramInfoHeader.setBorder(BorderFactory.createEtchedBorder());
            jpProgramInfoHeader.setMinimumSize(new Dimension(600, 40));
            jpProgramInfoHeader.setPreferredSize(new Dimension(600, 40));

            jlblProgramInfoHeader.setFont(new java.awt.Font("SansSerif", 1, 16));
            jlblProgramInfoHeader.setHorizontalAlignment(SwingConstants.CENTER);
            jlblProgramInfoHeader.setText("Program Details");

            jpProgramInfoStatus.setBorder(BorderFactory.createEtchedBorder());
            jpProgramInfoStatus.setMinimumSize(new Dimension(600, 30));
            jpProgramInfoStatus.setPreferredSize(new Dimension(600, 30));

            jlblProgramStatus.setHorizontalAlignment(SwingConstants.LEFT);
            jlblProgramStatus.setHorizontalTextPosition(SwingConstants.LEFT);
            jlblProgramStatus.setText("");

            jlblAuthenticationStatus.setHorizontalAlignment(SwingConstants.LEFT);
            jlblAuthenticationStatus.setHorizontalTextPosition(SwingConstants.LEFT);
            jlblAuthenticationStatus.setText("");

            jpProgramsList.setLayout(null);

            jspRegisteredPrograms.setBorder(BorderFactory.createEtchedBorder());
            jspRegisteredPrograms.setToolTipText("Registered Programs");
            jspRegisteredPrograms.setBounds(new Rectangle(43, 84, 201, 153));

            jspNewProgramsList.setToolTipText("New Programs");
            jspNewProgramsList.setBounds(new Rectangle(351, 85, 192, 155));
            jspNewProgramsList.setBorder(BorderFactory.createEtchedBorder());
            jlNewProgramsList.setNextFocusableComponent(jpPrograms);
            jlNewProgramsList.setToolTipText("New Programs");
            jlRegisteredPrograms.setBorder(null);
            jlRegisteredPrograms.setNextFocusableComponent(jbUnregister);
            jlRegisteredPrograms.setToolTipText("Registered Programs");
            jbUnregister.setBounds(new Rectangle(262, 119, 75, 21));
            jbUnregister.setNextFocusableComponent(jbRegister);
            jbUnregister.setToolTipText("Unregister Program");
            jbUnregister.setActionCommand("Unregister");
            jbUnregister.setMnemonic('>');
            jbUnregister.setText(">>");
            jbUnregister.addActionListener(new MainFrame_jbUnregister_actionAdapter(this));
            jbRegister.setText("<<");
            jbRegister.addActionListener(new MainFrame_jbRegister_actionAdapter(this));
            jbRegister.setBounds(new Rectangle(261, 173, 75, 21));
            jbRegister.setNextFocusableComponent(jlNewProgramsList);
            jbRegister.setToolTipText("Register Program");
            jbRegister.setActionCommand("Register");
            jbRegister.setMnemonic('<');
            jpProgramsList.setBorder(BorderFactory.createEtchedBorder());
            jlblRegisteredPrograms.setHorizontalAlignment(SwingConstants.CENTER);
            jlblRegisteredPrograms.setText("Registered Programs");
            jlblRegisteredPrograms.setBounds(new Rectangle(42, 38, 201, 32));
            jlblNewPrograms.setHorizontalAlignment(SwingConstants.CENTER);
            jlblNewPrograms.setText("UnRegistered Programs");
            jlblNewPrograms.setBounds(new Rectangle(351, 39, 190, 35));
            jpEventSoundInfoStatus.setBorder(BorderFactory.createEtchedBorder());
            jpEventSoundInfoStatus.setMinimumSize(new Dimension(600, 30));
            jpEventSoundInfoStatus.setPreferredSize(new Dimension(600, 30));
            jlblEventSoundInfoStatus.setHorizontalAlignment(SwingConstants.LEFT);
            jlblEventSoundInfoStatus.setHorizontalTextPosition(SwingConstants.LEFT);
            jlblEventSoundInfoStatus.setText("");
            jpEventSoundInfo.setLayout(blEventSoundInfo);
            jpEventSoundMapping.setLayout(null);
            jpEventSoundMapping.setBorder(BorderFactory.createEtchedBorder());
            jlblEventInfoHeader.setFont(new java.awt.Font("SansSerif", 1, 16));
            jlblEventInfoHeader.setHorizontalAlignment(SwingConstants.CENTER);
            jlblEventInfoHeader.setText("Event-Sound Mapping Information");
            jpEventInfoHeader.setBorder(BorderFactory.createEtchedBorder());
            jpEventInfoHeader.setMinimumSize(new Dimension(600, 40));
            jpEventInfoHeader.setPreferredSize(new Dimension(600, 40));
            jlblProgram.setText("Program");
            jlblProgram.setBounds(new Rectangle(153, 16, 142, 30));
            jcbProgramsList.setSelectedIndex(-1);
            jcbProgramsList.setBounds(new Rectangle(314, 16, 172, 30));
            jspEventSoundInfo.setBorder(BorderFactory.createEtchedBorder());
            jspEventSoundInfo.setBounds(new Rectangle(14, 71, 558, 233));
            jtEventSoundInfo.setToolTipText("Event Sound Info");
            jbUpdate.setBounds(new Rectangle(236, 319, 106, 32));
            jbUpdate.setToolTipText("Update Event Sound Info");
            jbUpdate.setActionCommand("Update");
            jbUpdate.setMnemonic('U');
            jbUpdate.setText("Update");
      jbUpdate.addActionListener(new MainFrame_jbUpdate_actionAdapter(this));
            jlblRecordedProgram.setBounds(new Rectangle(42, 38, 201, 32));
            jlblRecordedProgram.setText("Recorded Programs");
            jlblRecordedProgram.setHorizontalAlignment(SwingConstants.CENTER);
            jspOrdinaryPrograms.setBorder(BorderFactory.createEtchedBorder());
            jspOrdinaryPrograms.setBounds(new Rectangle(351, 85, 192, 155));
            jspOrdinaryPrograms.setToolTipText("New Programs");
            jspRecordedPrograms.setBorder(BorderFactory.createEtchedBorder());
            jspRecordedPrograms.setToolTipText("Recorded Programs");
            jspRecordedPrograms.setBounds(new Rectangle(43, 84, 201, 153));
            jlRecordedPrograms.setBorder(null);
            jlRecordedPrograms.setToolTipText("Recorded Programs");
            jlOrdinaryPrograms.setToolTipText("New Programs");
            jpRecorderStatus.setBorder(BorderFactory.createEtchedBorder());
            jpRecorderStatus.setMinimumSize(new Dimension(600, 30));
            jpRecorderStatus.setPreferredSize(new Dimension(600, 30));
            jlblRecorderStatus.setHorizontalAlignment(SwingConstants.LEFT);
            jlblRecorderStatus.setHorizontalTextPosition(SwingConstants.LEFT);
            jlblRecorderStatus.setText("");
            jpRecorder.setLayout(blRecorder);
            jbAddRecordedProgram.setText("<<");
      jbAddRecordedProgram.addActionListener(new MainFrame_jbAddRecordedProgram_actionAdapter(this));
            jbAddRecordedProgram.setBounds(new Rectangle(261, 173, 75, 21));
            jbAddRecordedProgram.setToolTipText("Register Program");
            jbAddRecordedProgram.setActionCommand("Register");
            jbAddRecordedProgram.setMnemonic('<');
            jlblUnrecordedPrograms.setHorizontalAlignment(SwingConstants.CENTER);
            jlblUnrecordedPrograms.setText("New Programs");
            jlblUnrecordedPrograms.setBounds(new Rectangle(351, 39, 190, 35));
            jpRecorderInfo.setLayout(null);
            jpRecorderInfo.setBorder(BorderFactory.createEtchedBorder());
            jlblRecorderHeader.setFont(new java.awt.Font("SansSerif", 1, 16));
            jlblRecorderHeader.setHorizontalAlignment(SwingConstants.CENTER);
            jlblRecorderHeader.setText("Recorder");
            jpRecorderHeader.setBorder(BorderFactory.createEtchedBorder());
            jpRecorderHeader.setMinimumSize(new Dimension(600, 40));
            jpRecorderHeader.setPreferredSize(new Dimension(600, 40));
            jbRemoveRecordedProgram.setBounds(new Rectangle(262, 119, 75, 21));
            jbRemoveRecordedProgram.setToolTipText("Unregister Program");
            jbRemoveRecordedProgram.setActionCommand("Unregister");
            jbRemoveRecordedProgram.setMnemonic('>');
            jbRemoveRecordedProgram.setText(">>");
      jbRemoveRecordedProgram.addActionListener(new MainFrame_jbRemoveRecordedProgram_actionAdapter(this));
            jpRecorder.setToolTipText("Recorder");
            jbPlay.setBounds(new Rectangle(45, 262, 81, 26));
            jbPlay.setToolTipText("Play Recorded Program");
      jbPlay.setMnemonic('P');
            jbPlay.setText("Play");
      jbPlay.addActionListener(new MainFrame_jbPlay_actionAdapter(this));
            jbStop.setText("Stop");
            //jbStop.setVisible(false);
      jbStop.addActionListener(new MainFrame_jbStop_actionAdapter(this));
            jbStop.setBounds(new Rectangle(152, 262, 81, 26));
            jbStop.setToolTipText("Stop Playing Program");
      jbStop.setMnemonic('S');
            jpPrograms.setNextFocusableComponent(jlRegisteredPrograms);
            jbUnregisterListener.setMnemonic('U');
            jbUnregisterListener.setActionCommand("LOGOUT");
            jbUnregisterListener.setToolTipText("Unregister Listener");
            jbUnregisterListener.setBounds(new Rectangle(165, 34, 113, 30));
            jbUnregisterListener.setText("Unregister");
            jbUnregisterListener.addActionListener(new MainFrame_jbUnregisterListener_actionAdapter(this));
            jbRegisterListener.setText("Register");
            jbRegisterListener.addActionListener(new MainFrame_jbRegisterListener_actionAdapter(this));
            jbRegisterListener.setMnemonic('R');
            jbRegisterListener.setActionCommand("LOGIN");
            jbRegisterListener.setToolTipText("Register Listener");
            jbRegisterListener.setBounds(new Rectangle(36, 34, 107, 30));
            this.getContentPane().add(jtpMain, BorderLayout.CENTER);
            jtpMain.add(jpAuthentication, "Authentication");
            jpRegister.add(jbRegisterListener, null);
            jpRegister.add(jbUnregisterListener, null);
            jpRegister.add(jbLogin, null);
            jpRegister.add(jbLogout, null);
            //jtpMain.add(jpPrograms,    "Program Info");
            jpNetworkInfo.add(jpNetworkInputs, BorderLayout.CENTER);
            jpNetworkInfo.add(jpRegister, BorderLayout.SOUTH);
            jpNetworkInputs.add(jtfHostIPAddress, null);
            jpNetworkInputs.add(jtfHostPortNo, null);
            jpNetworkInputs.add(jtfConfServerIPAddress, null);
            jpNetworkInputs.add(jtfConfServerPortNo, null);
            jpNetworkInputs.add(jlblHostIPAddress, null);
            jpNetworkInputs.add(jlblHostPortNo, null);
            jpNetworkInputs.add(jlblConfServerIPAddress, null);
            jpNetworkInputs.add(jlblConfServerPortNo, null);
            jpAuthentication.add(jpStatus, BorderLayout.SOUTH);
            jpAuthentication.add(jpHeader, BorderLayout.NORTH);
            jpHeader.add(jlblHeader, null);
            jpAuthentication.add(jpNetworkInfo, BorderLayout.CENTER);
            jpPrograms.add(jpProgramInfoHeader, BorderLayout.NORTH);
            jpProgramInfoHeader.add(jlblProgramInfoHeader, null);
            jpPrograms.add(jpProgramInfoStatus, BorderLayout.SOUTH);
            jpProgramInfoStatus.add(jlblProgramStatus, null);
            jpStatus.add(jlblAuthenticationStatus, null);
            jpPrograms.add(jpProgramsList, BorderLayout.CENTER);
            jpProgramsList.add(jspRegisteredPrograms, null);
            jspRegisteredPrograms.getViewport().add(jlRegisteredPrograms, null);
            jpProgramsList.add(jspNewProgramsList, null);
            jpProgramsList.add(jbUnregister, null);
            jspNewProgramsList.getViewport().add(jlNewProgramsList, null);
            jpProgramsList.add(jbRegister, null);
            jpProgramsList.add(jlblRegisteredPrograms, null);
            jpProgramsList.add(jlblNewPrograms, null);
            //jtpMain.add(jpEventSoundInfo,   "Event-Sound Info");
            jpEventSoundInfo.add(jpEventInfoHeader, BorderLayout.NORTH);
            jpEventInfoHeader.add(jlblEventInfoHeader, null);
            jpEventSoundInfo.add(jpEventSoundInfoStatus, BorderLayout.SOUTH);
            jpEventSoundInfoStatus.add(jlblEventSoundInfoStatus, null);
            jpEventSoundInfo.add(jpEventSoundMapping, BorderLayout.CENTER);
            jpEventSoundMapping.add(jspEventSoundInfo, null);
            jspEventSoundInfo.getViewport().add(jtEventSoundInfo, null);
      jpEventSoundMapping.add(jcbProgramsList, null);
      jpEventSoundMapping.add(jlblProgram, null);
      jpEventSoundMapping.add(jbUpdate, null);
            //jtpMain.add(jpRecorder,   "Recorder");
            jpRecorder.add(jpRecorderHeader, BorderLayout.NORTH);
            jpRecorderHeader.add(jlblRecorderHeader, null);
            jpRecorder.add(jpRecorderStatus, BorderLayout.SOUTH);
            jpRecorderStatus.add(jlblRecorderStatus, null);
            jpRecorder.add(jpRecorderInfo, BorderLayout.CENTER);
            jpRecorderInfo.add(jspRecordedPrograms, null);
            jpRecorderInfo.add(jspOrdinaryPrograms, null);
            jpRecorderInfo.add(jbRemoveRecordedProgram, null);
            jpRecorderInfo.add(jbAddRecordedProgram, null);
            jpRecorderInfo.add(jlblRecordedProgram, null);
            jpRecorderInfo.add(jlblUnrecordedPrograms, null);
            jspOrdinaryPrograms.setViewportView(jlOrdinaryPrograms);
            jspRecordedPrograms.setViewportView(jlRecordedPrograms);
            jpRecorderInfo.add(jbPlay, null);
            jpRecorderInfo.add(jbStop, null);
            jtEventSoundInfo.setModel(dtmEventSoundInfo);
            //initialiseEventSoundInfo();

            disableRegistrationFields();
            initialiseRegistrationFields();

            initialiseEventSoundInfoTable();

            //initialiseRecorderPane();

            addWindowListener(this);

        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void initialiseRecorderPane()
    {
        Vector vRecordedPrograms = objLM.getRecordedPrograms();

        if(vRecordedPrograms !=null)
        {
            System.out.println("Recorded programs Size : " + vRecordedPrograms.size());
            for(int iLoop=0; iLoop<vRecordedPrograms.size(); iLoop++)
            {
                dlmRecordedPrograms.addElement(vRecordedPrograms.get(iLoop));
            }
        }
        else
        {
            System.out.println("Recorded programs is NULL : ");
        }

        Enumeration enumRP = dlmRegisteredPrograms.elements();

        Vector vRegisteredPrograms = new Vector();

        System.out.println("Registered programs Size : " + vRegisteredPrograms.size());

        while(enumRP.hasMoreElements())
        {
            vRegisteredPrograms.add(enumRP.nextElement());
        }

        for(int iLoop=0; iLoop<vRegisteredPrograms.size();iLoop++)
        {

            if(vRecordedPrograms.contains(vRegisteredPrograms.get(iLoop))==false)
            {
                System.out.println(vRegisteredPrograms.get(iLoop) + " : ordinary programs");
                dlmOrdinaryPrograms.addElement(vRegisteredPrograms.get(iLoop));
            }
        }
    }

    private void initialiseEventSoundInfo()
    {
        //getProgramNames();
/*
        try
        {

            if(jcbProgramsList==null)
            {
                System.out.println("JCB is Null");
            }
            if(jcbProgramsList.getItemCount()>0)
            {
                jcbProgramsList.removeAllItems();
            }
        }
        catch(Exception e)
        {
            System.out.println("JCB Exception");
            e.printStackTrace();
        }
*/

        jcbProgramsList.addItem("Select Program");

        for(int iLoop=0; iLoop<dlmRegisteredPrograms.size();iLoop++)
        {
            jcbProgramsList.addItem(dlmRegisteredPrograms.getElementAt(iLoop));
        }

        jcbProgramsList.addItemListener( new ItemListener()
        {
          public void itemStateChanged(ItemEvent ie)
          {
              //dtmEventSoundInfo.setRowCount(0);
              for(int iLoop=0; iLoop<dtmEventSoundInfo.getRowCount();iLoop++)
              {
                dtmEventSoundInfo.removeRow(iLoop);
              }

              if(jcbProgramsList.getSelectedIndex() !=0 )
              {
                  Vector vEventSoundMappings = objLM.getEventSoundMappings((String)jcbProgramsList.getSelectedItem());
                  System.out.println("Size of Event Sound Mappings Length : "+vEventSoundMappings.size());

                  dtmEventSoundInfo.setRowCount(vEventSoundMappings.size());

                  for(int iLoop=0; iLoop<vEventSoundMappings.size(); iLoop++)
                  {

                      Vector vESM = (Vector)vEventSoundMappings.get(iLoop);

                      dtmEventSoundInfo.setValueAt(vESM.get(0), iLoop, 0); //First Column is Event name
                      dtmEventSoundInfo.setValueAt(vESM.get(7), iLoop, 1); //Second Column is Status
                      dtmEventSoundInfo.setValueAt(vESM.get(4), iLoop, 2); //Third Column is Default Sound Value
                      dtmEventSoundInfo.setValueAt(vESM.get(1), iLoop, 3); //Fourth Column is Current Sound Value
                  }
              }
              else
              {
                  dtmEventSoundInfo.setRowCount(0);
              }
          }
        });


    }


    private void removeProgramFromEventSoundTab(String sProgramName)
    {
        if(((String)jcbProgramsList.getSelectedItem()).equalsIgnoreCase(sProgramName))
        {
            dtmEventSoundInfo.setRowCount(0);
            jcbProgramsList.setSelectedIndex(0);
            jcbProgramsList.removeItem(sProgramName);
        }
        else
        {
            jcbProgramsList.removeItem(sProgramName);
        }
    }

    private void addProgramIntoEventSoundTab(String sProgramName)
    {
        jcbProgramsList.addItem(sProgramName);
    }

    private void initialiseEventSoundInfoTable()
    {
        jtEventSoundInfo.getColumnModel().getColumn(0).setCellEditor(new DefaultCellEditor(new TableField()));
        jtEventSoundInfo.getColumnModel().getColumn(2).setCellEditor(new DefaultCellEditor(new TableField()));
        jtEventSoundInfo.getColumnModel().getColumn(3).setCellEditor(new DefaultCellEditor(new TableField()));
        jtEventSoundInfo.getColumnModel().getColumn(4).setCellEditor(new SoundCellEditor());
        jtEventSoundInfo.getColumnModel().getColumn(4).setCellRenderer(new SoundCellRenderer());
    }



    public void showPanes()
    {

        jtpMain.add(jpPrograms, "Program Info");
        jtpMain.add(jpEventSoundInfo, "Event-Sound Info");
        jtpMain.add(jpRecorder, "Recorder");

        jtpMain.setSelectedIndex(1);
        //jtpMain.setEnabledAt(1,true);
    }

    public void removePanes()
    {
        jtpMain.remove(3);
        jtpMain.remove(2);
        jtpMain.remove(1);

    }

    public void initialiseRegistrationFields()
    {
      //System.out.println("($^8765482198463298734982734078230174");
        String sConfServerInfo[] = objLM.getConfigServerInfo();
        String sListenerInfo[] = objLM.getListenerInfo();

        if ((sConfServerInfo[0] != null) && (sListenerInfo[0] != null))
        {
            jtfConfServerIPAddress.setText(sConfServerInfo[0]);
            jtfConfServerPortNo.setText(sConfServerInfo[1]);

            jtfHostIPAddress.setText(sListenerInfo[0]);
            jtfHostPortNo.setText(sListenerInfo[1]);

            disableRegisterListener();
            enableUnregisterListener();
            enableLogin();
        }
        else
        {

            disableLogout();
            disableLogin();
            disableUnRegisterListener();
            enableRegisterListener();
        }
    }

    public static void main(String args[])
    {
        MainFrame objMF = new MainFrame();
        objMF.setBounds(100, 100, 600, 500);
        objMF.setVisible(true);
        objMF.show();
    }

    /**
     * Still need to be implemented.
     * @return
     */
    private String validateRegistrationFields()
    {
        return "SUCCESS";
    }

    void jbRegisterListener_actionPerformed(ActionEvent e)
    {

        String sValidatedMessage = validateRegistrationFields();
        if (sValidatedMessage.equalsIgnoreCase("SUCCESS") == true)
        {

            objLM.setNetworkInfo(jtfConfServerIPAddress.getText(), jtfConfServerPortNo.getText(), jtfHostIPAddress.getText(), jtfHostPortNo.getText());
            if (objLM.registerListener() == true)
            {
                disableRegisterListener();
                enableUnregisterListener();
                enableLogin();
            }
        }
        else
        {
            JOptionPane.showMessageDialog(null, sValidatedMessage, "ERROR", JOptionPane.ERROR_MESSAGE);
            return;
        }
    }

    private void clearRegistrationFields()
    {
        jtfConfServerIPAddress.setText("");
        jtfConfServerPortNo.setText("");
        jtfHostIPAddress.setText("");
        jtfHostPortNo.setText("");
    }

    /**
     * Clear all other tabs.
     * @param e
     */
    void jbUnregisterListener_actionPerformed(ActionEvent e)
    {

        if (objLM.unRegisterListener() == true)
        {
            clearRegistrationFields();

            disableLogin();
            disableLogout();
            disableUnRegisterListener();
            enableRegisterListener();
        }
    }

    void jbLogin_actionPerformed(ActionEvent e)
    {

        Vector[] vListOfPrograms = objLM.loginListener(jtfHostIPAddress.getText(), jtfHostPortNo.getText());

        if (vListOfPrograms != null)
        {
            enableUnregisterListener();
            disableLogin();
            enableLogout();

            showPanes();

            dlmRegisteredPrograms.removeAllElements();
            dlmNewProgramsList.removeAllElements();
            for (int iLoop = 0; iLoop < vListOfPrograms[0].size(); iLoop++)
            {
                dlmRegisteredPrograms.addElement(vListOfPrograms[0].get(iLoop));
            }

            for (int iLoop = 0; iLoop < vListOfPrograms[1].size(); iLoop++)
            {
                dlmNewProgramsList.addElement(vListOfPrograms[1].get(iLoop));
            }

            initialiseEventSoundInfo();
            initialiseRecorderPane();


        }
        else
        {
            System.out.println("Null returned by Login in login_ActionPerformed");
        }
    }

    private void clearProgramsPanel()
    {
        dlmNewProgramsList.removeAllElements();
        dlmRegisteredPrograms.removeAllElements();
    }

    /**
     * do clear operation for all tabs after logout is successful.
     * @param e
     */
    void jbLogout_actionPerformed(ActionEvent e)
    {
        if (objLM.logoutListener(jtfHostIPAddress.getText(), jtfHostPortNo.getText()) == true)
        {
            //do clear operation for all tabs.

            //jcbProgramsList.

            //jcbProgramsList.removeAllItems();

            disableLogout();
            enableLogin();
            clearProgramsPanel();
            removePanes();
            JOptionPane.showMessageDialog(null, "Logout Successful !", "Logged out", JOptionPane.PLAIN_MESSAGE);

            this.setVisible(false);
            System.exit(0);
        }
    }

    void jbUnregister_actionPerformed(ActionEvent e)
    {
        if (jlRegisteredPrograms.isSelectionEmpty() == false)
        {
            if (objLM.unRegisterProgram((String) jlRegisteredPrograms.getSelectedValue()) == true)
            {
                String sProgramName = (String) jlRegisteredPrograms.getSelectedValue();
                dlmNewProgramsList.addElement(sProgramName);
                if(dlmOrdinaryPrograms.indexOf(sProgramName)>0)
                {
                  dlmOrdinaryPrograms.removeElement(sProgramName);
                }

                if(dlmRecordedPrograms.indexOf(sProgramName)>0)
                {
                  dlmRecordedPrograms.removeElement(sProgramName);
                  //Remove the appropriate recorded program.
                }

                dlmRegisteredPrograms.removeElement(sProgramName);


                removeProgramFromEventSoundTab(sProgramName);
                JOptionPane.showMessageDialog(null, "Program '" + sProgramName + "' Unregistered !", "PROGRAM REMOVED", JOptionPane.PLAIN_MESSAGE);
            }
            else
            {
                JOptionPane.showMessageDialog(null, "Program Unregistration NOT Successful !", "PROGRAM NOT REMOVED", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    void jbRegister_actionPerformed(ActionEvent e)
    {
        if (jlNewProgramsList.isSelectionEmpty() == false)
        {
            if (objLM.registerProgram((String) jlNewProgramsList.getSelectedValue()) == true)
            {
                String sProgramName = (String) jlNewProgramsList.getSelectedValue();
                dlmRegisteredPrograms.addElement(sProgramName);
                dlmOrdinaryPrograms.addElement(sProgramName);

                dlmNewProgramsList.removeElement(sProgramName);
                addProgramIntoEventSoundTab(sProgramName);
                JOptionPane.showMessageDialog(null, "Program '" + sProgramName + "' Registered !", "PROGRAM REGISTERED", JOptionPane.PLAIN_MESSAGE);
            }
            else
            {
                JOptionPane.showMessageDialog(null, "Program Registration NOT Successful !", "PROGRAM NOT REGISTERED", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

  void jbUpdate_actionPerformed(ActionEvent e)
  {
     //objLM.changeEventSoundMapping()
      if(jcbProgramsList.getSelectedIndex() ==0)
      {
          JOptionPane.showMessageDialog(null, "No Program is Open !", "No Program is Open", JOptionPane.ERROR_MESSAGE);
          return;
      }

      Vector vEventNames = new Vector();
      Vector vEventSoundProperties = new Vector();

      for(int iLoop=0; iLoop<dtmEventSoundInfo.getRowCount(); iLoop++)
      {
        vEventNames.add(dtmEventSoundInfo.getValueAt(iLoop, 0));
        Vector vEventInfo = new Vector();

        vEventInfo.add(0, dtmEventSoundInfo.getValueAt(iLoop, 3)); //Sound
        vEventInfo.add(1, new Integer(0));                         //Pitch
        vEventInfo.add(2, new String(""));                         //Time

        String sSoundStatus = dtmEventSoundInfo.getValueAt(iLoop, 1).toString();
        if(sSoundStatus.trim().equalsIgnoreCase("true"))
        {
            vEventInfo.add(3, new Boolean(sSoundStatus)); //Status
        }
        else
        {
            vEventInfo.add(3, new Boolean(false)); //Status
        }


        vEventSoundProperties.add(vEventInfo);
      }
      objLM.updateProgramMapping((String)jcbProgramsList.getSelectedItem(), vEventNames, vEventSoundProperties);

      JOptionPane.showMessageDialog(null, "Event Sound Mappings Updated Successfully !", "Event Sound Mappings Updated", JOptionPane.INFORMATION_MESSAGE);
  }

  void jbRemoveRecordedProgram_actionPerformed(ActionEvent e)
  {
    if(jlRecordedPrograms.isSelectionEmpty()==false)
    {
      dlmOrdinaryPrograms.addElement(jlRecordedPrograms.getSelectedValue());

      objLM.stopRecording((String)jlRecordedPrograms.getSelectedValue());
      dlmRecordedPrograms.removeElementAt(jlRecordedPrograms.getSelectedIndex());

    }
  }

  void jbAddRecordedProgram_actionPerformed(ActionEvent e) {

    if(jlOrdinaryPrograms.isSelectionEmpty()==false)
    {
      dlmRecordedPrograms.addElement(jlOrdinaryPrograms.getSelectedValue());

      objLM.startRecording((String)jlOrdinaryPrograms.getSelectedValue());
      dlmOrdinaryPrograms.removeElementAt(jlOrdinaryPrograms.getSelectedIndex());
    }
  }

  void jbPlay_actionPerformed(ActionEvent e)
  {

      System.out.println("Play actionPerformed");
      jbPlay.setEnabled(false);
      jbStop.setEnabled(true);

       if(jlRecordedPrograms.isSelectionEmpty()==false)
       {
           System.out.println("Program Selected");
        if(objLM.playRecordedSound((String)jlRecordedPrograms.getSelectedValue())==false)
        {
            JOptionPane.showMessageDialog(null,"Program not yet recorded !!","Not Available", JOptionPane.INFORMATION_MESSAGE);
        }

       }

      jbPlay.setEnabled(true);
      jbStop.setEnabled(false);
  }

  void jbStop_actionPerformed(ActionEvent e)
  {

      objLM.stopPlayingRecordedProgram();

      jbPlay.setEnabled(true);
      jbStop.setEnabled(false);
  }
}


class MainFrame_jbRegisterListener_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbRegisterListener_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbRegisterListener_actionPerformed(e);
    }
}

class MainFrame_jbUnregisterListener_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbUnregisterListener_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbUnregisterListener_actionPerformed(e);
    }
}

class MainFrame_jbLogin_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbLogin_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbLogin_actionPerformed(e);
    }
}

class MainFrame_jbLogout_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbLogout_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbLogout_actionPerformed(e);
    }
}

class MainFrame_jbUnregister_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbUnregister_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbUnregister_actionPerformed(e);
    }
}

class MainFrame_jbRegister_actionAdapter implements java.awt.event.ActionListener
{
    MainFrame adaptee;

    MainFrame_jbRegister_actionAdapter(MainFrame adaptee)
    {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e)
    {
        adaptee.jbRegister_actionPerformed(e);
    }
}

class MainFrame_jbUpdate_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jbUpdate_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbUpdate_actionPerformed(e);
  }
}

class MainFrame_jbRemoveRecordedProgram_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jbRemoveRecordedProgram_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbRemoveRecordedProgram_actionPerformed(e);
  }
}

class MainFrame_jbAddRecordedProgram_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jbAddRecordedProgram_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbAddRecordedProgram_actionPerformed(e);
  }
}

class MainFrame_jbPlay_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jbPlay_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbPlay_actionPerformed(e);
  }
}

class MainFrame_jbStop_actionAdapter implements java.awt.event.ActionListener {
  MainFrame adaptee;

  MainFrame_jbStop_actionAdapter(MainFrame adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbStop_actionPerformed(e);
  }
}

